diff --git a/gcc/omp-low.c b/gcc/omp-low.c
index 3e519db..51bb617 100644
--- a/gcc/omp-low.c
+++ b/gcc/omp-low.c
@@ -5785,25 +5785,35 @@ gate_expand_omp (void)
   return (flag_openmp != 0 && !seen_error ());
 }
 
-struct gimple_opt_pass pass_expand_omp =
+class pass_expand_omp : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "ompexp",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_expand_omp,			/* gate */
-  execute_expand_omp,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_NONE,				/* tv_id */
-  PROP_gimple_any,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0                      		/* todo_flags_finish */
- }
-};
+public:
+  pass_expand_omp(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "ompexp",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_gimple_any),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_expand_omp (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_expand_omp (); }
+
+}; // class pass_expand_omp
+
+gimple_opt_pass *
+make_pass_expand_omp (context &ctxt)
+{
+  return new pass_expand_omp (ctxt);
+}
 
 /* Routines to lower OpenMP directives into OMP-GIMPLE.  */
 
@@ -6960,25 +6970,35 @@ execute_lower_omp (void)
   return 0;
 }
 
-struct gimple_opt_pass pass_lower_omp =
+class pass_lower_omp : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "omplower",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,					/* gate */
-  execute_lower_omp,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_NONE,				/* tv_id */
-  PROP_gimple_any,			/* properties_required */
-  PROP_gimple_lomp,			/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0                                     /* todo_flags_finish */
- }
-};
+public:
+  pass_lower_omp(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "omplower",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_gimple_any),
+				      provided(PROP_gimple_lomp),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_lower_omp (); }
+
+}; // class pass_lower_omp
+
+gimple_opt_pass *
+make_pass_lower_omp (context &ctxt)
+{
+  return new pass_lower_omp (ctxt);
+}
 
 /* The following is a utility to diagnose OpenMP structured block violations.
    It is not part of the "omplower" pass, as that's invoked too late.  It
@@ -7224,24 +7244,36 @@ gate_diagnose_omp_blocks (void)
   return flag_openmp != 0;
 }
 
-struct gimple_opt_pass pass_diagnose_omp_blocks =
+class pass_diagnose_omp_blocks : public gimple_opt_pass
 {
-  {
-    GIMPLE_PASS,
-    "*diagnose_omp_blocks",		/* name */
-    OPTGROUP_NONE,                      /* optinfo_flags */
-    gate_diagnose_omp_blocks,		/* gate */
-    diagnose_omp_structured_block_errors,	/* execute */
-    NULL,				/* sub */
-    NULL,				/* next */
-    0,					/* static_pass_number */
-    TV_NONE,				/* tv_id */
-    PROP_gimple_any,			/* properties_required */
-    0,					/* properties_provided */
-    0,					/* properties_destroyed */
-    0,					/* todo_flags_start */
-    0,					/* todo_flags_finish */
+public:
+  pass_diagnose_omp_blocks(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "*diagnose_omp_blocks",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_gimple_any),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_diagnose_omp_blocks (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () {
+    return diagnose_omp_structured_block_errors ();
   }
-};
+
+}; // class pass_diagnose_omp_blocks
+
+gimple_opt_pass *
+make_pass_diagnose_omp_blocks (context &ctxt)
+{
+  return new pass_diagnose_omp_blocks (ctxt);
+}
 
 #include "gt-omp-low.h"
diff --git a/gcc/passes.c b/gcc/passes.c
index 32c5bed..ed7ae6c 100644
--- a/gcc/passes.c
+++ b/gcc/passes.c
@@ -276,25 +276,37 @@ gate_all_early_local_passes (void)
   return (!seen_error () && !in_lto_p);
 }
 
-struct simple_ipa_opt_pass pass_early_local_passes =
-{
- {
-  SIMPLE_IPA_PASS,
-  "early_local_cleanups",		/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_all_early_local_passes,		/* gate */
-  execute_all_early_local_passes,	/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_EARLY_LOCAL,			/* tv_id */
-  0,					/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_remove_functions	 		/* todo_flags_finish */
- }
-};
+class pass_early_local_passes : public simple_ipa_opt_pass
+{
+public:
+  pass_early_local_passes(context &ctxt)
+    : simple_ipa_opt_pass(ctxt,
+			  "early_local_cleanups",
+			  OPTGROUP_NONE,
+			  TV_EARLY_LOCAL,
+			  pass_properties(required(0),
+					  provided(0),
+					  destroyed(0)),
+			  pass_todo_flags(start(0),
+					  finish(TODO_remove_functions)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_all_early_local_passes (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () {
+    return execute_all_early_local_passes ();
+  }
+
+}; // class pass_early_local_passes
+
+simple_ipa_opt_pass *
+make_pass_early_local_passes (context &ctxt)
+{
+  return new pass_early_local_passes (ctxt);
+}
 
 /* Gate: execute, or not, all of the non-trivial optimizations.  */
 
@@ -306,25 +318,35 @@ gate_all_early_optimizations (void)
 	  && !seen_error ());
 }
 
-static struct gimple_opt_pass pass_all_early_optimizations =
-{
- {
-  GIMPLE_PASS,
-  "early_optimizations",		/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_all_early_optimizations,		/* gate */
-  NULL,					/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_NONE,				/* tv_id */
-  0,					/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0					/* todo_flags_finish */
- }
-};
+class pass_all_early_optimizations : public gimple_opt_pass
+{
+public:
+  pass_all_early_optimizations(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "early_optimizations",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(0),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_all_early_optimizations (); }
+
+  bool has_execute () { return false; }
+  unsigned int impl_execute () { return 0; }
+
+}; // class pass_all_early_optimizations
+
+static gimple_opt_pass *
+make_pass_all_early_optimizations (context &ctxt)
+{
+  return new pass_all_early_optimizations (ctxt);
+}
 
 /* Gate: execute, or not, all of the non-trivial optimizations.  */
 
@@ -334,25 +356,35 @@ gate_all_optimizations (void)
   return optimize >= 1 && !optimize_debug;
 }
 
-static struct gimple_opt_pass pass_all_optimizations =
-{
- {
-  GIMPLE_PASS,
-  "*all_optimizations",			/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_all_optimizations,		/* gate */
-  NULL,					/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_OPTIMIZE,				/* tv_id */
-  0,					/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0					/* todo_flags_finish */
- }
-};
+class pass_all_optimizations : public gimple_opt_pass
+{
+public:
+  pass_all_optimizations(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "*all_optimizations",
+		      OPTGROUP_NONE,
+		      TV_OPTIMIZE,
+		      pass_properties(required(0),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_all_optimizations (); }
+
+  bool has_execute () { return false; }
+  unsigned int impl_execute () { return 0; }
+
+}; // class pass_all_optimizations
+
+static gimple_opt_pass *
+make_pass_all_optimizations (context &ctxt)
+{
+  return new pass_all_optimizations (ctxt);
+}
 
 /* Gate: execute, or not, all of the non-trivial optimizations.  */
 
@@ -362,25 +394,35 @@ gate_all_optimizations_g (void)
   return optimize >= 1 && optimize_debug;
 }
 
-static struct gimple_opt_pass pass_all_optimizations_g =
-{
- {
-  GIMPLE_PASS,
-  "*all_optimizations_g",		/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_all_optimizations_g,		/* gate */
-  NULL,					/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_OPTIMIZE,				/* tv_id */
-  0,					/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0					/* todo_flags_finish */
- }
-};
+class pass_all_optimizations_g : public gimple_opt_pass
+{
+public:
+  pass_all_optimizations_g(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "*all_optimizations_g",
+		      OPTGROUP_NONE,
+		      TV_OPTIMIZE,
+		      pass_properties(required(0),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_all_optimizations_g (); }
+
+  bool has_execute () { return false; }
+  unsigned int impl_execute () { return 0; }
+
+}; // class pass_all_optimizations_g
+
+static gimple_opt_pass *
+make_pass_all_optimizations_g (context &ctxt)
+{
+  return new pass_all_optimizations_g (ctxt);
+}
 
 static bool
 gate_rest_of_compilation (void)
@@ -390,25 +432,35 @@ gate_rest_of_compilation (void)
   return !(rtl_dump_and_exit || flag_syntax_only || seen_error ());
 }
 
-static struct rtl_opt_pass pass_rest_of_compilation =
-{
- {
-  RTL_PASS,
-  "*rest_of_compilation",               /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_rest_of_compilation,             /* gate */
-  NULL,                                 /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_REST_OF_COMPILATION,               /* tv_id */
-  PROP_rtl,                             /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  0                                     /* todo_flags_finish */
- }
-};
+class pass_rest_of_compilation : public rtl_opt_pass
+{
+public:
+  pass_rest_of_compilation(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "*rest_of_compilation",
+		   OPTGROUP_NONE,
+		   TV_REST_OF_COMPILATION,
+		   pass_properties(required(PROP_rtl),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_rest_of_compilation (); }
+
+  bool has_execute () { return false; }
+  unsigned int impl_execute () { return 0; }
+
+}; // class pass_rest_of_compilation
+
+static rtl_opt_pass *
+make_pass_rest_of_compilation (context &ctxt)
+{
+  return new pass_rest_of_compilation (ctxt);
+}
 
 static bool
 gate_postreload (void)
@@ -416,25 +468,35 @@ gate_postreload (void)
   return reload_completed;
 }
 
-static struct rtl_opt_pass pass_postreload =
-{
- {
-  RTL_PASS,
-  "*all-postreload",                        /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_postreload,                      /* gate */
-  NULL,                                 /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_POSTRELOAD,                        /* tv_id */
-  PROP_rtl,                             /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_verify_rtl_sharing               /* todo_flags_finish */
- }
-};
+class pass_postreload : public rtl_opt_pass
+{
+public:
+  pass_postreload(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "*all-postreload",
+		   OPTGROUP_NONE,
+		   TV_POSTRELOAD,
+		   pass_properties(required(PROP_rtl),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_verify_rtl_sharing)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_postreload (); }
+
+  bool has_execute () { return false; }
+  unsigned int impl_execute () { return 0; }
+
+}; // class pass_postreload
+
+static rtl_opt_pass *
+make_pass_postreload (context &ctxt)
+{
+  return new pass_postreload (ctxt);
+}
 
 
 
diff --git a/gcc/postreload-gcse.c b/gcc/postreload-gcse.c
index b9befe0..fa62379 100644
--- a/gcc/postreload-gcse.c
+++ b/gcc/postreload-gcse.c
@@ -1322,23 +1322,32 @@ rest_of_handle_gcse2 (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_gcse2 =
+class pass_gcse2 : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "gcse2",                              /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_handle_gcse2,                    /* gate */
-  rest_of_handle_gcse2,                 /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_GCSE_AFTER_RELOAD,                 /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_verify_rtl_sharing
-  | TODO_verify_flow                    /* todo_flags_finish */
- }
-};
+public:
+  pass_gcse2(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "gcse2",
+		   OPTGROUP_NONE,
+		   TV_GCSE_AFTER_RELOAD,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_verify_rtl_sharing | TODO_verify_flow)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_handle_gcse2 (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rest_of_handle_gcse2 (); }
+
+}; // class pass_gcse2
+
+rtl_opt_pass *
+make_pass_gcse2 (context &ctxt)
+{
+  return new pass_gcse2 (ctxt);
+}
diff --git a/gcc/postreload.c b/gcc/postreload.c
index 33462e4..d91c91e 100644
--- a/gcc/postreload.c
+++ b/gcc/postreload.c
@@ -2300,23 +2300,32 @@ rest_of_handle_postreload (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_postreload_cse =
+class pass_postreload_cse : public rtl_opt_pass
 {
- {
-  RTL_PASS,
-  "postreload",                         /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_handle_postreload,               /* gate */
-  rest_of_handle_postreload,            /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_RELOAD_CSE_REGS,                   /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_finish | TODO_verify_rtl_sharing |
-  0                                     /* todo_flags_finish */
- }
-};
+public:
+  pass_postreload_cse(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "postreload",
+		   OPTGROUP_NONE,
+		   TV_RELOAD_CSE_REGS,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_verify_rtl_sharing | 0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_handle_postreload (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rest_of_handle_postreload (); }
+
+}; // class pass_postreload_cse
+
+rtl_opt_pass *
+make_pass_postreload_cse (context &ctxt)
+{
+  return new pass_postreload_cse (ctxt);
+}
diff --git a/gcc/predict.c b/gcc/predict.c
index 91f66a8..3d3dcd1 100644
--- a/gcc/predict.c
+++ b/gcc/predict.c
@@ -2900,45 +2900,67 @@ predictor_name (enum br_predictor predictor)
   return predictor_info[predictor].name;
 }
 
-struct gimple_opt_pass pass_profile =
-{
- {
-  GIMPLE_PASS,
-  "profile_estimate",			/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_estimate_probability,		/* gate */
-  tree_estimate_probability_driver,	/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_BRANCH_PROB,			/* tv_id */
-  PROP_cfg,				/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_verify_ssa			/* todo_flags_finish */
- }
-};
+class pass_profile : public gimple_opt_pass
+{
+public:
+  pass_profile(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "profile_estimate",
+		      OPTGROUP_NONE,
+		      TV_BRANCH_PROB,
+		      pass_properties(required(PROP_cfg),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_ssa)))
+  {}
 
-struct gimple_opt_pass pass_strip_predict_hints =
-{
- {
-  GIMPLE_PASS,
-  "*strip_predict_hints",		/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,					/* gate */
-  strip_predict_hints,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_BRANCH_PROB,			/* tv_id */
-  PROP_cfg,				/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_verify_ssa			/* todo_flags_finish */
- }
-};
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_estimate_probability (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () {
+    return tree_estimate_probability_driver ();
+  }
+
+}; // class pass_profile
+
+gimple_opt_pass *
+make_pass_profile (context &ctxt)
+{
+  return new pass_profile (ctxt);
+}
+
+class pass_strip_predict_hints : public gimple_opt_pass
+{
+public:
+  pass_strip_predict_hints(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "*strip_predict_hints",
+		      OPTGROUP_NONE,
+		      TV_BRANCH_PROB,
+		      pass_properties(required(PROP_cfg),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return strip_predict_hints (); }
+
+}; // class pass_strip_predict_hints
+
+gimple_opt_pass *
+make_pass_strip_predict_hints (context &ctxt)
+{
+  return new pass_strip_predict_hints (ctxt);
+}
 
 /* Rebuild function frequencies.  Passes are in general expected to
    maintain profile by hand, however in some cases this is not possible:
diff --git a/gcc/recog.c b/gcc/recog.c
index ed359f6..476d17f 100644
--- a/gcc/recog.c
+++ b/gcc/recog.c
@@ -3748,26 +3748,35 @@ rest_of_handle_peephole2 (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_peephole2 =
-{
- {
-  RTL_PASS,
-  "peephole2",                          /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_handle_peephole2,                /* gate */
-  rest_of_handle_peephole2,             /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_PEEPHOLE2,                         /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_df_finish | TODO_verify_rtl_sharing |
-  0                                    /* todo_flags_finish */
- }
-};
+class pass_peephole2 : public rtl_opt_pass
+{
+public:
+  pass_peephole2(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "peephole2",
+		   OPTGROUP_NONE,
+		   TV_PEEPHOLE2,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_df_finish | TODO_verify_rtl_sharing | 0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_handle_peephole2 (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rest_of_handle_peephole2 (); }
+
+}; // class pass_peephole2
+
+rtl_opt_pass *
+make_pass_peephole2 (context &ctxt)
+{
+  return new pass_peephole2 (ctxt);
+}
 
 static unsigned int
 rest_of_handle_split_all_insns (void)
@@ -3776,25 +3785,37 @@ rest_of_handle_split_all_insns (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_split_all_insns =
-{
- {
-  RTL_PASS,
-  "split1",                             /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,                                 /* gate */
-  rest_of_handle_split_all_insns,       /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_NONE,                              /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  0                                     /* todo_flags_finish */
- }
-};
+class pass_split_all_insns : public rtl_opt_pass
+{
+public:
+  pass_split_all_insns(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "split1",
+		   OPTGROUP_NONE,
+		   TV_NONE,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () {
+    return rest_of_handle_split_all_insns ();
+  }
+
+}; // class pass_split_all_insns
+
+rtl_opt_pass *
+make_pass_split_all_insns (context &ctxt)
+{
+  return new pass_split_all_insns (ctxt);
+}
 
 static unsigned int
 rest_of_handle_split_after_reload (void)
@@ -3807,25 +3828,37 @@ rest_of_handle_split_after_reload (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_split_after_reload =
-{
- {
-  RTL_PASS,
-  "split2",                             /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,                                 /* gate */
-  rest_of_handle_split_after_reload,    /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_NONE,                              /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  0                                     /* todo_flags_finish */
- }
-};
+class pass_split_after_reload : public rtl_opt_pass
+{
+public:
+  pass_split_after_reload(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "split2",
+		   OPTGROUP_NONE,
+		   TV_NONE,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () {
+    return rest_of_handle_split_after_reload ();
+  }
+
+}; // class pass_split_after_reload
+
+rtl_opt_pass *
+make_pass_split_after_reload (context &ctxt)
+{
+  return new pass_split_after_reload (ctxt);
+}
 
 static bool
 gate_handle_split_before_regstack (void)
@@ -3852,25 +3885,37 @@ rest_of_handle_split_before_regstack (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_split_before_regstack =
-{
- {
-  RTL_PASS,
-  "split3",                             /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_handle_split_before_regstack,    /* gate */
-  rest_of_handle_split_before_regstack, /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_NONE,                              /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  0                                     /* todo_flags_finish */
- }
-};
+class pass_split_before_regstack : public rtl_opt_pass
+{
+public:
+  pass_split_before_regstack(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "split3",
+		   OPTGROUP_NONE,
+		   TV_NONE,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_handle_split_before_regstack (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () {
+    return rest_of_handle_split_before_regstack ();
+  }
+
+}; // class pass_split_before_regstack
+
+rtl_opt_pass *
+make_pass_split_before_regstack (context &ctxt)
+{
+  return new pass_split_before_regstack (ctxt);
+}
 
 static bool
 gate_handle_split_before_sched2 (void)
@@ -3891,25 +3936,37 @@ rest_of_handle_split_before_sched2 (void)
   return 0;
 }
 
-struct rtl_opt_pass pass_split_before_sched2 =
-{
- {
-  RTL_PASS,
-  "split4",                             /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_handle_split_before_sched2,      /* gate */
-  rest_of_handle_split_before_sched2,   /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_NONE,                              /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_verify_flow                      /* todo_flags_finish */
- }
-};
+class pass_split_before_sched2 : public rtl_opt_pass
+{
+public:
+  pass_split_before_sched2(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "split4",
+		   OPTGROUP_NONE,
+		   TV_NONE,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_verify_flow)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_handle_split_before_sched2 (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () {
+    return rest_of_handle_split_before_sched2 ();
+  }
+
+}; // class pass_split_before_sched2
+
+rtl_opt_pass *
+make_pass_split_before_sched2 (context &ctxt)
+{
+  return new pass_split_before_sched2 (ctxt);
+}
 
 /* The placement of the splitting that we do for shorten_branches
    depends on whether regstack is used by the target or not.  */
@@ -3923,22 +3980,32 @@ gate_do_final_split (void)
 #endif
 }
 
-struct rtl_opt_pass pass_split_for_shorten_branches =
-{
- {
-  RTL_PASS,
-  "split5",                             /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_do_final_split,                  /* gate */
-  split_all_insns_noflow,               /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_NONE,                              /* tv_id */
-  0,                                    /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_verify_rtl_sharing               /* todo_flags_finish */
- }
-};
+class pass_split_for_shorten_branches : public rtl_opt_pass
+{
+public:
+  pass_split_for_shorten_branches(context &ctxt)
+    : rtl_opt_pass(ctxt,
+		   "split5",
+		   OPTGROUP_NONE,
+		   TV_NONE,
+		   pass_properties(required(0),
+				   provided(0),
+				   destroyed(0)),
+		   pass_todo_flags(start(0),
+				   finish(TODO_verify_rtl_sharing)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_do_final_split (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return split_all_insns_noflow (); }
+
+}; // class pass_split_for_shorten_branches
+
+rtl_opt_pass *
+make_pass_split_for_shorten_branches (context &ctxt)
+{
+  return new pass_split_for_shorten_branches (ctxt);
+}
